<?PHP

	/* microURL v1.0.0 - written by paal d. ekran, Fri Dec 11 16:51:49 CET 2009 

	   requirement:
		- a web server (apache) - either a dedicated server or running on a separate port
		- php with sqlite compiled in (--with-sqlite)

	   install:
		- add the following to the web-server's httpd.conf file:
		    RewriteEngine On
			RewriteRule   ^/(.*)  /index.php?c=$1$2$3
		  Example virtual host configuration (httpd.config):
				Listen 8000
				<VirtualHost *:8000>
  					DocumentRoot /system/apache/htdocs.micro
  					ServerName host.com
  					ServerAlias host.com
  					RewriteEngine On
  					RewriteRule   ^/(.*)  /index.php?c=$1$2$3
 					ErrorLog logs/host.micro-error_log
  					CustomLog logs/host.micro-access_log combined
				</VirtualHost>

	    - edit the $host and $dbfile variables below
        - ensure that the file refered to in $dbfile is writable by the web-server
          (touch file, chown "serveruser" file)
		- type: http://hosturl/init to create the db.

		todo:
		 - there is no check on alias for valid characters
         - there is no check for the validity of the url

 	*/

	$host='http://athena.cc.uit.no:8000/'; // base
	$dbfile='/system/apache/data/redirect.db'; // must be writable by apache

	// -----------------------------------------------------------------------
	
	date_default_timezone_set('Europe/Oslo');

	$out=""; // collect output in this variable, then print it out at the end	
	$c=sqlite_escape_string($_GET['c']);

	// check database connection and create db if needed	
	if (!$db=sqlite_open ($dbfile,0666,$err))
	{
		$out.="Could not connect to the redirect database.<br>\n";
		print $out."<br>";
		exit;
	}

	//	if !command entered write input window
	if (!$c)
	{
		$out.=addmicro($host,$db);
	} else {
		// create the database (assuming it isn't there already)
		if ($c=='init')
		{
			$out.="INITIALIZING DATABASE...<br>\n";
			$sql="CREATE TABLE murl (mhash VARCHAR(20),murl TEXT,mdate UNSIGNED INT,mip VARCHAR(24))";
			$result=@sqlite_query($sql,$db);
			if (!$result) 
			{
				$out.="ERROR: Could not create database tables (maybe they already exist?)<br>\n";	
			} else {
				$out.='The database has been initialized.<p><a href="'.$host.'">Continue</a>';
			}	
		} else {
			// search DB for $c
			$sql='SELECT murl FROM murl WHERE mhash="'.$c.'"';
			$result=sqlite_query($sql,$db);
			$row=sqlite_fetch_array($result);
			$murl=stripslashes($row['murl']);
			// redirect permanent to murl
			header ("HTTP/1.1 301 Moved Permanently");
			header ("Location: http://".$murl);
			exit;	
		}
	}

	print $out."\n";
	exit;

	function addmicro($host,$db)
	{
		global $db;

		// some fancy css
		$out='<html>
<head>
<title>&micro;URL</title>
<style type="text/css">
    body  {font-family:sans-serif;font-size:13px;cursor:default;color:#000000;}
    td    {font-family:sans-serif;font-size:13px;cursor:default;color:#000000;}
    a       {color:#303030;text-decoration:none;}
    a:hover {color:#ffbc48;text-decoration:none;background-color:#000000;}
    input {border-width:1px;font-family:arial,sans-serif;font-size:12px;padding:2px;height:21px;
            border-color:#000000;border-style:solid;background-color:#f9f9f9;color:#000000;}
    textarea {border-width:1px;font-family:arial,sans-serif;font-size:12px;padding:2px;
            border-color:#000000;border-style:solid;background-color:#f9f9f9;color:#999999;}
</style>
<body>
<br><br><br>
<table bgcolor="#000000" align="center" width="75%"><tr><td>
<table width="100%" bgcolor="#b0b0b0"><tr><td>
<center><h2>&micro;URL</h2></center>
';

		// process submission
		if ($_POST['curl'])
		{
			$curl=sqlite_escape_string($_POST['curl']);
			$calt=sqlite_escape_string($_POST['calt']);
			if (preg_match("/^http:/",$curl))
			{
				$curl=preg_replace ("/^http:\/\//i","",$curl);
			}
			$base='23456789abcdefghjkmnpqrstuvwxyzABCDEFGHJKMNPQRSTUVWXYZ'; // exclude confusing: 10oOil

			// check if this url already exist and print old reference if it does
			$sql='SELECT * FROM murl WHERE murl="'.$curl.'"';
			$result=sqlite_query($sql,$db);
			$row=sqlite_fetch_array($result);

			// this url already exist in the database and alias was not used - write out link
            // information. 
			if (($row['mhash']) && (!$calt))
			{
				$out.='<table align="center" width="80%">
					<tr><td>The &micro;URL: <a href="'.$host.stripslashes($row['mhash']).'">'.
					$host.stripslashes($row['mhash']).'</a><br>
			           Redirects to: <a href="http://'.$curl.'">http://'.$curl.'</a><br><br>
					</td></tr></table>';
				$out.=input_form($host);
				$out.=wtail();
				return ($out);
			}

			// handle alternative hash reference
			if ($calt)
			{
				if (do_exist($calt,$db))
				{
					$out.='<center><b>'.$host.$calt."</b> has already been used!<br>
						press 'back' and try a new custom alias.<p></center>\n";
					$out.=wtail();
					return ($out);
				} else {
					$mhash=$calt;
				}
			} else { // generate random hash
				do {
					$mhash="";
					for ($cnt=0; $cnt<5; $cnt++)
					{
						$mhash.=$base[rand(0,strlen($base))];
					}
				} while (do_exist($mhash,$db)); // try until you get an unique identifier
			}

			// insert the new entry into the database
			$sql='INSERT INTO murl (murl,mhash,mdate,mip) VALUES ("'.$curl.'","'.$mhash.'",'.date("U").',"'.$_SERVER['REMOTE_ADDR'].'")';
			$result=sqlite_query($sql,$db);
			if ($result)
			{
				$out.='<table align="center" width="80%">
					<tr><td>The &micro;URL: <a href="'.$host.$mhash.'">'.$host.$mhash.'</a><br>
			           Redirects to: <a href="http://'.$curl.'">http://'.$curl.'</a><br><br>
					</td></tr></table>';
				$out.=input_form($host);
			} else {
				$out.='FAILED TO ADD &micro;URL TO THE DATABASE.<br>';
			}
		} else {
			$out.=input_form($host);
		}
		$out.=wtail();
		return ($out);
	}

	// write out a simple input form
	function input_form($host)
	{
		return ('
<form action="" method="POST">
<table align="center" width="80%" align="center">
<tr><td>Enter&nbsp;URL:</td>
    <td width="100%"><b>http://</b><input type="text" size="60" name="curl"></td></tr>
<tr><td></td>
    <td><input type="submit" name="csubmit" value="create &micro;URL"></td></tr>
<tr><td colspan="2"><hr></td></tr>
<tr><td valign="top">Custom&nbsp;Alias&nbsp;(optional):</td>
    <td>'.$host.'<input type="text" size="12" name="calt"><br>
        (may only contain letters and numbers)</td></tr>
</table>
<br>
</form>');
	}

	// returns true if this url already exist.
	function do_exist($burl,$db)
	{
		$sql='SELECT murl FROM murl WHERE mhash="'.$burl.'"';
		$result=sqlite_query($sql,$db);
		$row=sqlite_fetch_array($result);
		if ($row['murl']) { return (1); }  // the url already exist
		return (0); // the url does not exist
	}

	// end the HTML code
	function wtail()
	{
		return ('
</td></tr></table>
</td></tr></table>
</body>
</html>');
	}

?>
